%% program to test the scattering approach
clear all
fontsize = 14;linewidth = 2;
period = linspace(6,20,100);number_of_angles = 100;
concentration=1;time_step = 0;

c_g =  9.81*period/(4*pi);% the group_speed

theta = linspace(0,2*pi-2*pi/number_of_angles,number_of_angles) - pi/2 + pi/number_of_angles;


%%
for plot_case = 1:4
    
    switch plot_case
        case 1
            floe_thickness = 0.5;name = '05';
        case 2
            floe_thickness = 1;name = '1';
        case 3
            floe_thickness = 1.5;name = '15';
        case 4
            floe_thickness = 2;name = '2';
    end
    
    
    radius = 25;
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    %
    
    for count = 1:length(Fourier_cosine_D)
        [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D(count),number_of_angles,concentration,time_step);
        S_store(count) = S(1,1);
    end
    
    semilogy(period,-S_store./c_g,'LineWidth',linewidth)
    hold on
    
    %%
    radius = 50;
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    %
    
    for count = 1:length(Fourier_cosine_D)
        [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D(count),number_of_angles,concentration,time_step);
        S_store(count) = S(1,1);
    end
    
    semilogy(period,-S_store./c_g,'LineWidth',linewidth)

    
    %%
    radius = 100;
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    
    
    for count = 1:length(Fourier_cosine_D)
        [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D(count),number_of_angles,concentration,time_step);
        S_store(count) = S(1,1);
    end
    
    semilogy(period,-S_store./c_g,'LineWidth',linewidth)
    
    %%
    radius = 200;
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    
    
    for count = 1:length(Fourier_cosine_D)
        [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D(count),number_of_angles,concentration,time_step);
        S_store(count) = S(1,1);
    end
    
    semilogy(period,-S_store./c_g,'LineWidth',linewidth)
    
    hold off
    
    xlim([6,20])
    xlabel('$T$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$\alpha_s$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
    
    legend('a = 25','a = 50','a = 100','a = 200')
    
    
    eval(['print -depsc ../figures/atteunation_thickness',name]);
    
end


