%% program to test the scattering approach
clear all
fontsize = 14;
radius = 50;floe_thickness = 1;period = 8;number_of_angles = 6;
concentration=1;time_step = 0;

theta = linspace(0,2*pi-2*pi/number_of_angles,number_of_angles) - pi/2 + pi/number_of_angles

Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);

[S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D,number_of_angles,concentration,time_step);

%% non-dimensionalize




c_g =  9.81*period/(4*pi);

T = 1/(-S(1,1));
L = c_g*T;

D = diag(cos(theta));
M = T*S;

N = 8*1024;
x = linspace(0,100,N);

N_count = 1:N;
% N = 1024;
% D = diag(1/2*[2,1,-1,-2]);
% M= -[3,-1,-1,-1;-1,3,-1,-1;-1,-1,3,-1;-1,-1,-1,3];

% we want the pulse to be one hour away
distance = 1000;
non_dimensional_distance = distance/L

delta_x = x(2) - x(1);
incident = [0*exp(-(x-5).^2);exp(-(x-non_dimensional_distance).^2);0*exp(-(x-5).^2)];
incident_edge = [0*exp(-(x/D(1,1)-5).^2);exp(-(x/D(2,2)-non_dimensional_distance).^2);0*exp(-(x/D(2,2)-5).^2)];
matrix_size = size(D,1);


% M= zeros(size(M));
delta_t = delta_x;

% plot(x,incident)




%% solve using spectral theory
f_hat = fft(incident.').';

% lambda = linspace(0,3,100);
delta_k = 2*pi/(N*delta_x);

lambda = [0:delta_k:N/2*delta_k,-(N/2-1)*delta_k:delta_k:-delta_k];

% V_store = zeros(matrix_size,length(x),length(lambda));
% kappa_store= zeros(1,length(lambda));
V_store = zeros(matrix_size,length(x),matrix_size/2,length(lambda));
%    V_store2 = zeros(matrix_size,length(x),matrix_size/2,length(lambda));

for count1 = 1:matrix_size/2
    if max(abs(f_hat(count1,:))) ~= 0
        for count = N_count(abs(f_hat(count1,:))/max(abs(f_hat(count1,:))) > 1e-10)
            [V,D1] = eig(D\(M - 1i*lambda(count)*eye(size(M))));
            [y,i] = sort(real(diag(D1)));
            %     V(:,i(1:2))/V(1:2,i(1:2))
            inv_V = inv(V(1:matrix_size/2,i(1:matrix_size/2)));
            for count2 = 1:matrix_size/2
                
                V_store(:,:,count1,count) =  V_store(:,:,count1,count)  + ...
                    f_hat(count1,count)*inv_V(count2,count1)*V(:,i(count2))*exp(D1(i(count2),i(count2))*x);
                %               V_store2(:,:,count1,count) =  V_store2(:,:,count1,count)  + ...
                %                 inv_V(count2,count1)*V(:,i(count2))*exp(D1(i(count2),i(count2))*x);
                
            end
        end
        %     V_temp = V_temp +
        %     V_temp  = f_hat(1,count)*[exp(D1(i(1),i(1))*x)*V(1,i(1))*inv_V(1,1) + ...
        %         exp(D1(i(2),i(2))*x)*V(1,i(2))*inv_V(2,1);...
        %         exp(D1(i(1),i(1))*x)*V(2,i(1))*inv_V(1,1) + ...
        %         exp(D1(i(2),i(2))*x)*V(2,i(2))*inv_V(2,1);...
        %         exp(D1(i(1),i(1))*x)*V(3,i(1))*inv_V(1,1) + ...
        %         exp(D1(i(2),i(2))*x)*V(3,i(2))*inv_V(2,1);...
        %         exp(D1(i(1),i(1))*x)*V(4,i(1))*inv_V(1,1) + ...
        %         exp(D1(i(2),i(2))*x)*V(4,i(2))*inv_V(2,1)];
        %     V_store(:,:,count) = V_temp;
    end
end
% V_store2 = permute(V_store,[4,2,1,3]);

% u_out1 = ifft(transpose(squeeze(V_store(1,:,2,:))));
tic
u_out = ifft(V_store,N,4);
toc
% u_out2 = ifft(transpose(squeeze(V_store(2,:,2,:))));
% u_out3 = ifft(transpose(squeeze(V_store(3,:,2,:))));
% u_out4 = ifft(transpose(squeeze(V_store(4,:,2,:))));

% offset = mean(real(u_out(:,end)))

e_power_s = expm(delta_x*M);

%%
u = zeros(matrix_size,length(x));
for count = 1:1000
    disp(count)
    for count1 = 1:matrix_size/2
        % positive moving
        u(count1,2:end) = D(count1,count1)*u(count1,1:end-1) + ...
            (1-D(count1,count1))*u(count1,2:end);
        u(count1,1)= D(count1,count1)*incident_edge(count1,count) + ...
            (1-D(count1,count1))*u(count1,1);
        %         u(count1,1)
    end
    for count1 = matrix_size/2+1 :matrix_size
        % negative moving
        u(count1,1:end-1) = -D(count1,count1)*u(count1,2:end) + ...
            (1+D(count1,count1))*u(count1,1:end-1);
        u(count1,end)= (1+D(count1,count1))*u(count1,end);
    end
    
    u = e_power_s*u;
    %     u(1,1)
    plot(L*x,u(1,:),L*x,u(2,:),L*x,u(3,:),L*x,u(4,:))
    hold on
    %     plot(x,real(u_out(count,:,1,2)),'r--',x,real(u_out(count,:,2,2)),'k--',...
    %         x,real(u_out(count,:,3,2)),'b--',x,real(u_out(count,:,4,2)),'g--')
    plot(L*x(1:20:end),real(u_out(1,1:20:end,2,count)),'ro',L*x,real(u_out(2,:,2,count)),'k--',...
        L*x,real(u_out(3,:,2,count)),'b--',L*x,real(u_out(4,:,2,count)),'g--')
    hold off
    axis([0,L*10,0,1])
    drawnow
    
end



%%

%%
clf
    plot_count = 2;
     delta_x*count*T/60
     
             plot(L*x,real(u_out(plot_count,:,2,228)),'k-',...
           L*x,real(u_out(plot_count,:,2,341)),'b-',...
           L*x,real(u_out(plot_count,:,2,455)),'r-')
        legend('t = 1 min','t = 2 min','t = 3 min')
        legend('AutoUpdate','Off')
        hold on
        
u = zeros(matrix_size,length(x));
for count = 1:455
    disp(count)
    for count1 = 1:matrix_size/2
        % positive moving
        u(count1,2:end) = D(count1,count1)*u(count1,1:end-1) + ...
            (1-D(count1,count1))*u(count1,2:end);
        u(count1,1)= D(count1,count1)*incident_edge(count1,count) + ...
            (1-D(count1,count1))*u(count1,1);
        %         u(count1,1)
    end
    for count1 = matrix_size/2+1 :matrix_size
        % negative moving
        u(count1,1:end-1) = -D(count1,count1)*u(count1,2:end) + ...
            (1+D(count1,count1))*u(count1,1:end-1);
        u(count1,end)= (1+D(count1,count1))*u(count1,end);
    end
    
    
    u = e_power_s*u;
    %     u(1,1)

  
        
    if (count == 228) 
              plot(L*x(1:20:end),u(plot_count,1:20:end),'ko')
    elseif (count == 341)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'bo')
    elseif(count == 455)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'ro')
       
        
  
        %     plot(x,real(u_out(count,:,1,2)),'r--',x,real(u_out(count,:,2,2)),'k--',...
        %         x,real(u_out(count,:,3,2)),'b--',x,real(u_out(count,:,4,2)),'g--')
    
       end
      
     
 
        
end

hold off

  xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$N_2$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
  xlim([0,L*10])
print -depsc ../figures/comparison1

%%

    plot_count = 3;
     delta_x*count*T/60
     
             plot(L*x,real(u_out(plot_count,:,2,228)),'k-',...
           L*x,real(u_out(plot_count,:,2,341)),'b-',...
           L*x,real(u_out(plot_count,:,2,455)),'r-')
        legend('t = 1 min','t = 2 min','t = 3 min')
        legend('AutoUpdate','Off')
        hold on
        
u = zeros(matrix_size,length(x));
for count = 1:455
    disp(count)
    for count1 = 1:matrix_size/2
        % positive moving
        u(count1,2:end) = D(count1,count1)*u(count1,1:end-1) + ...
            (1-D(count1,count1))*u(count1,2:end);
        u(count1,1)= D(count1,count1)*incident_edge(count1,count) + ...
            (1-D(count1,count1))*u(count1,1);
        %         u(count1,1)
    end
    for count1 = matrix_size/2+1 :matrix_size
        % negative moving
        u(count1,1:end-1) = -D(count1,count1)*u(count1,2:end) + ...
            (1+D(count1,count1))*u(count1,1:end-1);
        u(count1,end)= (1+D(count1,count1))*u(count1,end);
    end
    
    
    u = e_power_s*u;
    %     u(1,1)

  
        
    if (count == 228) 
              plot(L*x(1:20:end),u(plot_count,1:20:end),'ko')
    elseif (count == 341)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'bo')
    elseif(count == 455)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'ro')
       
        
  
        %     plot(x,real(u_out(count,:,1,2)),'r--',x,real(u_out(count,:,2,2)),'k--',...
        %         x,real(u_out(count,:,3,2)),'b--',x,real(u_out(count,:,4,2)),'g--')
    
       end
      
     
 
        
end

hold off

  xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$N_3$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
  xlim([0,L*10])
print -depsc ../figures/comparison2

%%

    plot_count = 4;
     delta_x*count*T/60
     
             plot(L*x,real(u_out(plot_count,:,2,228)),'k-',...
           L*x,real(u_out(plot_count,:,2,341)),'b-',...
           L*x,real(u_out(plot_count,:,2,455)),'r-')
        legend('t = 1 min','t = 2 min','t = 3 min')
        legend('AutoUpdate','Off')
        hold on
        
u = zeros(matrix_size,length(x));
for count = 1:455
    disp(count)
    for count1 = 1:matrix_size/2
        % positive moving
        u(count1,2:end) = D(count1,count1)*u(count1,1:end-1) + ...
            (1-D(count1,count1))*u(count1,2:end);
        u(count1,1)= D(count1,count1)*incident_edge(count1,count) + ...
            (1-D(count1,count1))*u(count1,1);
        %         u(count1,1)
    end
    for count1 = matrix_size/2+1 :matrix_size
        % negative moving
        u(count1,1:end-1) = -D(count1,count1)*u(count1,2:end) + ...
            (1+D(count1,count1))*u(count1,1:end-1);
        u(count1,end)= (1+D(count1,count1))*u(count1,end);
    end
    
    
    u = e_power_s*u;
    %     u(1,1)

  
        
    if (count == 228) 
              plot(L*x(1:20:end),u(plot_count,1:20:end),'ko')
    elseif (count == 341)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'bo')
    elseif(count == 455)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'ro')
       
        
  
        %     plot(x,real(u_out(count,:,1,2)),'r--',x,real(u_out(count,:,2,2)),'k--',...
        %         x,real(u_out(count,:,3,2)),'b--',x,real(u_out(count,:,4,2)),'g--')
    
       end
      
     
 
        
end

hold off

  xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$N_4$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
  xlim([0,L*10])
print -depsc ../figures/comparison3


%%

    plot_count = 5;
     delta_x*count*T/60
     
             plot(L*x,real(u_out(plot_count,:,2,228)),'k-',...
           L*x,real(u_out(plot_count,:,2,341)),'b-',...
           L*x,real(u_out(plot_count,:,2,455)),'r-')
        legend('t = 1 min','t = 2 min','t = 3 min')
        legend('AutoUpdate','Off')
        hold on
        
u = zeros(matrix_size,length(x));
for count = 1:455
    disp(count)
    for count1 = 1:matrix_size/2
        % positive moving
        u(count1,2:end) = D(count1,count1)*u(count1,1:end-1) + ...
            (1-D(count1,count1))*u(count1,2:end);
        u(count1,1)= D(count1,count1)*incident_edge(count1,count) + ...
            (1-D(count1,count1))*u(count1,1);
        %         u(count1,1)
    end
    for count1 = matrix_size/2+1 :matrix_size
        % negative moving
        u(count1,1:end-1) = -D(count1,count1)*u(count1,2:end) + ...
            (1+D(count1,count1))*u(count1,1:end-1);
        u(count1,end)= (1+D(count1,count1))*u(count1,end);
    end
    
    
    u = e_power_s*u;
    %     u(1,1)

  
        
    if (count == 228) 
              plot(L*x(1:20:end),u(plot_count,1:20:end),'ko')
    elseif (count == 341)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'bo')
    elseif(count == 455)
        plot(L*x(1:20:end),u(plot_count,1:20:end),'ro')
       
        
  
        %     plot(x,real(u_out(count,:,1,2)),'r--',x,real(u_out(count,:,2,2)),'k--',...
        %         x,real(u_out(count,:,3,2)),'b--',x,real(u_out(count,:,4,2)),'g--')
    
       end
      
     
 
        
end

hold off

  xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$N_5$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
  xlim([0,L*10])
print -depsc ../figures/comparison4







