%% program to draw the spectral results
clear all
clf
fontsize = 14;linewidth = 2;


time = 120;dist = 500;


load data42angle
% u_combined is angle, x, time
%     time = 240;distance = 500;

x_value0 = 1;
x_value1 = round(dist/delta_x/L);
x_value2 = round(2*dist/delta_x/L);
x_value3 = round(3*dist/delta_x/L);
t_value1 = round(time/delta_x/T);
t_value2 = round(2*time/delta_x/T);
t_value3 = round(3*time/delta_x/T);
% x_value*delta_x*L
% t_value*delta_x*T


%%
%
polarplot(theta.',u_combined(:,x_value1,t_value1),'b-','LineWidth',linewidth)
rlim([0,0.4])
hold on
polarplot(theta.',u_combined(:,x_value1,t_value2),'k-','LineWidth',linewidth)
hold on
polarplot(theta.',u_combined(:,x_value1,t_value3),'r-','LineWidth',linewidth)
hold off

%     xticks([ -pi/2,0, pi/2, pi, 3*pi/2])
%     xticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
%     xlabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
%     ylabel('$N$','Interpreter','Latex','Fontsize',fontsize)
legend('t = 2 min','t = 4 min','t = 6 min','Location','best')
legend('boxoff')


set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
%     xlim([-pi/2,3*pi/2])
print -depsc ../figures/spectral_evolution1

% pause

clf

polarplot(theta.',u_combined(:,x_value2,t_value1),'b-','LineWidth',linewidth)
rlim([0,0.1])
hold on
polarplot(theta.',u_combined(:,x_value2,t_value2),'k-','LineWidth',linewidth)
hold on
polarplot(theta.',u_combined(:,x_value2,t_value3),'r-','LineWidth',linewidth)
hold off

%     xticks([ -pi/2,0, pi/2, pi, 3*pi/2])
%     xticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
%     xlabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
%     ylabel('$N$','Interpreter','Latex','Fontsize',fontsize)
legend('t = 4 min','t = 8 min','t = 12 min','Location','best')
legend('boxoff')


set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
%     xlim([-pi/2,3*pi/2])
print -depsc ../figures/spectral_evolution2

polarplot(theta.',u_combined(:,x_value3,t_value1),'b-','LineWidth',linewidth)
rlim([0,0.02])
hold on
polarplot(theta.',u_combined(:,x_value3,t_value2),'k-','LineWidth',linewidth)
hold on
polarplot(theta.',u_combined(:,x_value3,t_value3),'r-','LineWidth',linewidth)
hold off

%     xticks([ -pi/2,0, pi/2, pi, 3*pi/2])
%     xticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
%     xlabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
%     ylabel('$N$','Interpreter','Latex','Fontsize',fontsize)
legend('t = 4 min','t = 8 min','t = 12 min','Location','best')
legend('boxoff')


set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
%     xlim([-pi/2,3*pi/2])
print -depsc ../figures/spectral_evolution3

% pause

polarplot(theta.',u_combined(:,x_value0,t_value1),'b-','LineWidth',linewidth)
rlim([0,0.5])
hold on
polarplot(theta.',u_combined(:,x_value0,t_value2),'k-','LineWidth',linewidth)
hold on
polarplot(theta.',u_combined(:,x_value0,t_value3),'r-','LineWidth',linewidth)
hold off

%     xticks([ -pi/2,0, pi/2, pi, 3*pi/2])
%     xticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
%     xlabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
%     ylabel('$N$','Interpreter','Latex','Fontsize',fontsize)
legend('t = 4 min','t = 8 min','t = 12 min','Location','best')
legend('boxoff')


set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
%     xlim([-pi/2,3*pi/2])
print -depsc ../figures/spectral_evolution0

% end


%%
[X,Y] = meshgrid(L*x(1:100),theta);
mesh(X,Y,u_combined(:,1:100,t_value1))
set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
ylim([-pi/2,3*pi/2])
view(-37+180,30)
yticks([ 0, pi/2, pi, 3*pi/2, 2*pi])
yticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
ylabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
zlabel('$N$','Interpreter','Latex','Fontsize',fontsize)

print -depsc ../figures/spectral_evolution_mesh1

[X,Y] = meshgrid(L*x(1:100),theta);
mesh(X,Y,u_combined(:,1:100,t_value2))
set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
ylim([-pi/2,3*pi/2])
view(-37+180,30)
yticks([ 0, pi/2, pi, 3*pi/2, 2*pi])
yticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
ylabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
zlabel('$N$','Interpreter','Latex','Fontsize',fontsize)

print -depsc ../figures/spectral_evolution_mesh2

[X,Y] = meshgrid(L*x(1:100),theta);
mesh(X,Y,u_combined(:,1:100,t_value3))
set(gca,'LineWidth',2)
set(gca,'Fontsize',fontsize)
ylim([-pi/2,3*pi/2])
view(-37+180,30)
yticks([ 0, pi/2, pi, 3*pi/2, 2*pi])
yticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})
ylabel('$\theta$','Interpreter','Latex','Fontsize',fontsize)
xlabel('$x$','Interpreter','Latex','Fontsize',fontsize)
zlabel('$N$','Interpreter','Latex','Fontsize',fontsize)

print -depsc ../figures/spectral_evolution_mesh3






