%% program to test the scattering approach
clear all

for data_count = 1:3
    switch data_count
        case 1
            number_of_angles = 12; name = 'data12angle';
        case 2
            number_of_angles = 22; name = 'data22angle';
        case 3
            number_of_angles = 42; name = 'data42angle';
    end
    tic
    fontsize = 14;
    radius = 50;floe_thickness = 1;period = 8;
    concentration=1;time_step = 0;
    
    theta = linspace(0,2*pi-2*pi/number_of_angles,number_of_angles) - pi/2 + pi/number_of_angles;
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D,number_of_angles,concentration,time_step);
    toc
    %% non-dimensionalize
    tic
    
    
    
    c_g =  9.81*period/(4*pi);
    
    T = 1/(-S(1,1));
    L = c_g*T;
    
    D = diag(cos(theta));
    M = T*S;
    
    N = 1024;
    x = linspace(0,100,N);
    
    N_count = 1:N;
    % N = 1024;
    % D = diag(1/2*[2,1,-1,-2]);
    % M= -[3,-1,-1,-1;-1,3,-1,-1;-1,-1,3,-1;-1,-1,-1,3];
    
    % we want the pulse to be one hour away
    distance = 1000;
    non_dimensional_distance = distance/L;
    
    delta_x = x(2) - x(1);
    incident = zeros(number_of_angles/2,length(x));
    for count = 1:number_of_angles/2
        incident(count,:) = exp(-(x-non_dimensional_distance).^2)*...
            cos(theta(count))^2;
    end
    matrix_size = size(D,1);
    
    
    % M= zeros(size(M));
    delta_t = delta_x;
    
    % incident = exp(-(x-5).^2);
    % incident2 = exp(-(2*x-5).^2);
    %
    % plot(x,incident)
    
    
    
    
    %% solve using spectral theory
    f_hat = fft(incident.').';
    
    % lambda = linspace(0,3,100);
    delta_k = 2*pi/(N*delta_x);
    
    lambda = [0:delta_k:N/2*delta_k,-(N/2-1)*delta_k:delta_k:-delta_k];
    
    % V_store = zeros(matrix_size,length(x),length(lambda));
    % kappa_store= zeros(1,length(lambda));
    V_store = zeros(matrix_size,length(x),matrix_size/2,length(lambda));
    %    V_store2 = zeros(matrix_size,length(x),matrix_size/2,length(lambda));
    
    for count1 = 1:matrix_size/2
        if max(abs(f_hat(count1,:))) ~= 0
            for count = N_count(abs(f_hat(count1,:))/max(abs(f_hat(count1,:))) > 1e-10)
                [V,D1] = eig(D\(M - 1i*lambda(count)*eye(size(M))));
                [y,i] = sort(real(diag(D1)));
                %     V(:,i(1:2))/V(1:2,i(1:2))
                inv_V = inv(V(1:matrix_size/2,i(1:matrix_size/2)));
                for count2 = 1:matrix_size/2
                    
                    V_store(:,:,count1,count) =  V_store(:,:,count1,count)  + ...
                        f_hat(count1,count)*inv_V(count2,count1)*V(:,i(count2))*exp(D1(i(count2),i(count2))*x);
                    
                end
            end
            
        end
    end
    %
    toc
    
    tic
    u_out = real(ifft(V_store,N,4));
    toc
    
    % u_out has four dimensions. Tne first is number of angle. The second is
    % the x dependence the third is the the incident angle - i.e. the results
    % for each incident angle are stored separately.  The last one is the time variable.
    
    
    u_combined = squeeze(sum(u_out,3));
    u_combined = u_combined(:,1:512,1:512);
    
    clear u_out V_store
    
    save(name)
    
end



