%% program to test the scattering approach
clear all
close all
fontsize = 14;
for plot_count = 1:4
    switch plot_count
        case 1
            number_of_angles = 4;name = '4';
             type = 'k-';
        case 2
            number_of_angles = 6;name = '6';
             type = 'b-';
        case 3
            number_of_angles = 8;name = '8';
             type = 'r-';
        case 4
            number_of_angles = 10;name = '10';
             type = 'g-';
    end
    
    radius = 50;floe_thickness = 1;period = 8;
    concentration=1;time_step = 0;
    
    theta = linspace(0,2*pi-2*pi/number_of_angles,number_of_angles) - pi/2 + pi/number_of_angles
    
    Fourier_cosine_D = Fourier_cosine_D_make(radius, floe_thickness,period);
    
    [S,exp_S_delta_t] = scattering_matrix(Fourier_cosine_D,number_of_angles,concentration,time_step);
    
    %% non-dimensionalize
    c_g =  9.81*period/(4*pi);
    
    T = 1/(-S(1,1));
    L = c_g*T;
    
    D = diag(cos(theta));
    M = T*S;
    
    % D = [1,-0;0,-1];M= [1,-1;-1,1];
    
    mu = linspace(0,20,10000);
    lambda_store = zeros(length(mu),length(diag(D)));
    
    count = 1;
    [V,D1] = eig(1i*mu(count)*D + M);
    lambda_store(count,:) = diag(D1);
    
    for count = 2:length(mu)
        [V,D1] = eig(1i*mu(count)*D + M);
        D1 = diag(D1);
        for count2 = 1:length(diag(D))
            [y,i] = min(abs(D1 - lambda_store(count-1,count2)));
            lambda_store(count,count2) = D1(i);
            D1(i) = inf;
        end
        
    end
    % hold off
    
    
    %%
%     subplot(2,2,plot_count)
    for count2 = 1:length(diag(D))
                plot(-1i*lambda_store(:,count2),type,'LineWidth',2)
        axis([-5,5,0,2])
        hold on
        
    end
    hold off
   xlabel('$\textrm{Re}(\lambda)$','Interpreter','Latex','Fontsize',fontsize)
    ylabel('$\textrm{Im}(\lambda)$','Interpreter','Latex','Fontsize',fontsize)
    
    set(gca,'LineWidth',2)
    set(gca,'Fontsize',fontsize)
    
       eval(['print -depsc ../figures/spectrum',name]);
end

% hold off